<template>
  <v-container style="max-width: 600px">
    <v-timeline>
      <v-timeline-item
        v-for="(dataObjs, i) in dataObj"
        :key="i"
        small
        color="error"
      >
        <template v-slot:opposite>
          <span
            v-text="new Date(dataObjs.date).toISOString().substr(0, 10)"
          ></span>
        </template>

        <v-card
          class="elevation-2"
          outlined
          color="indigo"
          v-for="(store, j) in dataObjs.name"
          :key="j"
        >
          <v-card-text class="white text--primary mt-1">
            ร้าน {{ store.name }} ใช้จ่ายไป
            {{
              parseInt(store.price).toLocaleString('th-TH', {
                style: 'currency',
                currency: 'THB',
              })
            }}
          </v-card-text>
        </v-card>
      </v-timeline-item>
    </v-timeline>
  </v-container>
</template>
<script>
import { mapGetters, mapActions, mapState } from 'vuex'

export default {
  data: () => ({
    events: [],
    input: null,
    nonce: 0,
    dataObj: [],
  }),
  watch: {
    getExpensesTable() {
      this.testFunction(this.$nuxt.$store.state.expensestable.ExpensesTable)
    },
  },
  computed: {
    ...mapState({
      getExpensesTable: (state) => state.expensestable.ExpensesTable,
    }),
  },
  mounted() {
    this.callTableAll()
  },

  methods: {
    ...mapActions({
      callTableAll: 'callTableAll',
    }),
    testFunction(exTable) {
      const lastDate = new Date(new Date().toISOString().substr(0, 10))
      const getLastDate = lastDate.getTime()

      const dayStart = getLastDate - (86400000 * 30)
      const dayEnd = getLastDate
      const dataRes = this.totalTypeMulti(exTable, dayStart, dayEnd)

      const merged = dataRes.reduce((r, { date, color, ...rest }) => {
        const key = `${date}-${color}`
        r[key] = r[key] || {
          date,
          color,
          name: [],
        }
        r[key]['name'].push(rest)
        return r
      }, {})

      const timeTable = Object.values(merged)

      this.dataObj = timeTable.sort((a, b) =>
        a.date > b.date ? -1 : a.date < b.date ? 1 : 0
      )
    },
    totalTypeMulti(dataRes, dataStart, dateEnd) {
      const dateFunction = this.filterdate(dataRes, dataStart, dateEnd)

      // จัดกรุ๊ปใหม่
      let newObj = []
      dateFunction.forEach((data) => {
        newObj = [
          ...newObj,
          {
            id: data.storesExpenses.id,
            name: data.storesExpenses.name,
            date: new Date(data.date).getTime(),
            price: data.price,
          },
        ]
      })
      // คำนวนผลรวมแยกตาม วันที่ และ ไอดี ประเภทค่าใช้จ่าย
      var helper = {}
      var resultVal = newObj.reduce(function (prev, cur) {
        var key = cur.date + '-' + cur.id

        if (!helper[key]) {
          helper[key] = Object.assign({}, cur) // create a copy of o
          prev.push(helper[key])
        } else {
          helper[key].price += cur.price
        }
        return prev
      }, [])
      return resultVal
    },
    filterdate(dataRes, dataStart, dateEnd) {
      let firstDate = parseInt(dataStart)
      let lastDate = parseInt(dateEnd) + 86390000
      const dateFind = dataRes.filter((dataval) => {
        return (
          new Date(dataval.date).getTime() >= firstDate &&
          new Date(dataval.date).getTime() <= lastDate
        )
      })

      return dateFind
    },
  },
}
</script>
